import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.io.*;
import java.util.*;

public class DatagramEco extends MIDlet implements Runnable, CommandListener {

    private Form formEco;
    private TextField mensagem;
    private TextField eco;

	/* Os comandos da aplicao					*/
	private Command cmdSair,  cmdBuscar, cmdComando;

	/* A thread que envia os comandos para o servidor	*/
	private Thread executor = null;

	/* Flag para interromper a thread 					*/
	private boolean pararThread = false;

	/* A lista de comandos a enviar, funciona como uma pilha	*/
	private Vector comandos = new Vector();

	private UDPDatagramConnection udpDC = null;

    public DatagramEco() {
     	cmdSair = new Command("Sair", Command.EXIT, 1);
      	cmdBuscar = new Command("Enviar", Command.SCREEN, 1);
		cmdComando = new Command("Comando", Command.SCREEN, 1);

      	formEco = new Form("Mensagem");
      	mensagem = new TextField("Mensagem", "Ola", 256, TextField.ANY);
      	eco = new TextField("Eco", "", 256, TextField.ANY);
      	formEco.append(mensagem);
      	formEco.append(eco);
      	formEco.addCommand(cmdSair);
      	formEco.addCommand(cmdBuscar);
      	formEco.addCommand(cmdSair);
      	formEco.setCommandListener(this);
      	executor = new Thread(this);
      	executor.start();
    }

    public void startApp() {
      	Display.getDisplay(this).setCurrent(formEco);
    }

	public void destroyApp(boolean unconditional) {
		pararThread();
	}

	public void pauseApp() {
	}

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSair) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == cmdBuscar) {
			adicionaComando(mensagem.getString());
		}
	}


	private void adicionaComando(String comando) {
		synchronized(comandos) {
			comandos.addElement(comando);
			comandos.notify();
		}
	}

	private void pararThread() {
		pararThread = true;
		if (udpDC != null) {
			try {
				udpDC.close();
			} catch (IOException ioe) {
			}
		}
		synchronized(comandos) {
			comandos.notify();
		}
		if (executor != null) {
			try {
				executor.join();
			} catch (InterruptedException ie) {
				System.err.println("Excepo:" + ie.getMessage());
			}
		}
	}

	public void run() {
		String comando = null;

		Datagram pedido = null;
		Datagram resposta = null;

		byte dados[];

		/* criar a ligao por datagrama ao servidor	*/
		try {
			 /**/udpDC = (UDPDatagramConnection)Connector.open("datagram://127.0.0.1:1234");/**/
			System.out.println("Tamanho Mximo: "+ udpDC.getMaximumLength());
			System.out.println("Tamanho Nominal: "+ udpDC.getNominalLength());
			System.out.println(udpDC.getLocalAddress() + ":" + udpDC.getLocalPort());

		} catch (IOException ioe) {
			Alert a = new Alert("Erro", ioe.getMessage(), null, null);
			a.setTimeout(Alert.FOREVER);
			Display.getDisplay(this).setCurrent(a, formEco);
			return;
		}

		while (!pararThread) {
			comando = null;
			synchronized(comandos) {
				if (comandos.size() > 0) {
					comando = (String)comandos.elementAt(0);
					comandos.removeElementAt(0);
				} else {
					try {
						comandos.wait();
					} catch (InterruptedException ie) {

					}
				}
			}
			/* enviar o datagrama e esperar resposta	*/
			if (comando != null) {
				try {
					/**//* preparar o datagrama para enviar	*/
					dados = comando.getBytes();
					pedido = udpDC.newDatagram(dados, dados.length);
					udpDC.send(pedido);
					System.out.println(udpDC.getLocalAddress() + ":" + udpDC.getLocalPort());
					/* receber a resposta				*/
					resposta = udpDC.newDatagram(udpDC.getMaximumLength());
					udpDC.receive(resposta);

					/* ler os dados da datagrama recebido	*/
					long timeStamp = resposta.readLong();
					String ecoResposta = resposta.readUTF();

					Date data = new Date(timeStamp);

					System.out.println(resposta.getAddress());
					eco.setString(data.toString() + ": " + ecoResposta);/**/
				} catch (IOException ioe) {
					System.err.println("Excepo de IO: " + ioe.getMessage());
				}
			}

		}
		try {

			if (udpDC != null) {
				udpDC.close();
			}
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
	}
}